<!--
Calendar implementation for the HTWK Leipzig timetable. Evaluation and display of the individual dates in iCal format.
Copyright (C) 2024 HTWKalender support@htwkalender.de

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
-->

<script setup lang="ts">
import { Ref, ref } from "vue";
import { Module } from "@/model/module";
import moduleStore from "@/store/moduleStore";
import { getCalender } from "@/api/loadCalendar";
import { router } from "@/main";
import tokenStore from "@/store/tokenStore";
import { useToast } from "primevue/usetoast";
import { useI18n } from "vue-i18n";
import DynamicPage from "@/view/DynamicPage.vue";
const { t } = useI18n({ useScope: "global" });

const toast = useToast();

const token: Ref<string> = ref("");
const modules: Ref<Map<string, Module>> = ref(moduleStore().modules);

const tokenRegex = /^[a-z0-9]{15}$/;
const tokenUriRegex = /[?&]token=([a-z0-9]{15})(?:&|$)/;

const isToken = (token: string): boolean => {
  return tokenRegex.test(token) || tokenUriRegex.test(token);
};

function extractToken(token: string): string {
  if (tokenRegex.test(token)) {
    return token;
  }

  const match = tokenUriRegex.exec(token);
  if (match) {
    return match[1];
  }

  throw new Error("Invalid token");
}

function loadCalendar(): void {
  try {
    token.value = extractToken(token.value);
  } catch (error) {
    toast.add({
      severity: "error",
      summary: t("editCalendarView.error"),
      detail: t("editCalendarView.invalidToken"),
      life: 3000,
    });
    console.error(error);
    return;
  }

  moduleStore().removeAllModules();
  tokenStore().setToken(token.value);

  getCalender(token.value).then((data: Module[]) => {
    if (data.length > 0) {
      data.forEach((module) => {
        moduleStore().addModule(module);
      });
      modules.value = moduleStore().modules;
      router.push("/edit-calendar");
    } else {
      toast.add({
        severity: "error",
        summary: t("editCalendarView.error"),
        detail: t("editCalendarView.noCalendarFound"),
        life: 3000,
      });
    }
  });
}
</script>

<template>
  <DynamicPage
    hide-content
    :headline="t('editCalendarView.headline')"
    :sub-title="t('editCalendarView.subTitle')"
    icon="pi pi-pencil"
    :button="{
      label: t('editCalendarView.loadCalendar'),
      icon: 'pi pi-arrow-down',
      disabled: !isToken(token),
      onClick: loadCalendar,
    }"
  >
    <template #selection="{ flexSpecs }">
      <InputText
        v-model="token"
        type="text"
        :class="flexSpecs"
        autofocus
        @keyup.enter="loadCalendar"
      />
    </template>
  </DynamicPage>
</template>

<style scoped></style>
